function love.keypressed(key)
	if game.state == "menu" then
		if key == "left" then player[1].x = player[1].x - 100 end
		if key == "right" then player[1].x = player[1].x + 100 end
		if key == "up" then player[1].y = player[1].y - 100 end
		if key == "down" then player[1].y = player[1].y + 100 end
	end
	if game.status == "playing" then
		if key == "z" and #player[1].bombs < player[1].n_bomb then
			local posx,posy = math.floor(player[1].x % cellsize), math.floor(player[1].y % cellsize)
			local bx, by = world:toCell(player[1].x,player[1].y)
			if posx < cellsize/2 then bx = bx - 1 end
			if posy < cellsize/2 then by = by - 1 end
			local newBomb = {x=bx*cellsize, y=by*cellsize, rubber=player[1].rubber, fuse=player[1].fuse, name="bomb", moving="n", speed=0, id=#player[1].bombs}
			CheckPath(newBomb,"center")
		end
	end
	if key == "1" then print("p X: "..math.floor(player[1].x/32)) end
	if key == "2" then print("p Y: "..math.floor(player[1].y/32)) end
	if key == "3" then print(GetRealPos(player[1].x,player[1].y)) end
end

function ControlUpdate(dt)
	local PlayerFilter = function(item,other) --item = player, other = o quê colidiu com ele
		if other.name == "block" then return 'slide'
		elseif other.name == "breakable" and item.passwall == "n" then return 'slide'
		elseif other.name == "breakable" and item.passwall == "y" then return 'cross'
		elseif other.type == "enemy" then return 'cross'
		elseif other.name == "powerup" then return 'cross'
		elseif other.name == "explosion" then return 'cross'
		
		elseif other.name == "bomb" and item.passbomb == "n" and
			   ((item.x - other.x >= 0 and item.x - other.x < 1*cellsize) or
			    (item.x - other.x <= 0 and item.x - other.x > -1*cellsize)) and
			   ((item.y - other.y >= 0 and item.y - other.y < 1*cellsize) or
				(item.y - other.y <= 0 and item.y - other.y > -1*cellsize)) then
			   return 'cross'
		
		elseif other.name == "bomb" and item.passbomb == "n" then return 'slide'
		elseif other.name == "bomb" and item.passbomb == "y" then return 'cross'
		end
	end
		
	local BombFilter = function(item,other)
		if item.rubber == "y" and (other.name == "block" or other.name == "breakable") then return 'bounce'
		else return 'slide'
		end
	end
	
	local speed = player[1].speed
	local dx, dy = 0, 0
	if love.keyboard.isDown('right') then dx = speed * dt end
	if love.keyboard.isDown('left') then dx = -speed * dt end
	if love.keyboard.isDown('down') then dy = speed * dt end
	if love.keyboard.isDown('up') then dy = -speed * dt end

	if dx ~= 0 or dy ~= 0 then
		local cols, posx, posy
		local actualx, actualy, cols, cols_len = world:check(player[1], player[1].x + dx, player[1].y + dy, PlayerFilter)
		
		if cols_len > 0 then
			for i=1,cols_len do
				local col = cols[i]
				if col.other.name == "explosion" then col.item.life = col.item.life -1
				elseif col.other.name == "powerup" then PickPowerup(col.other,player[1])--colisão errada, acontece se eu intencionar me mover, pegando itens onde eu não poderia
				--se for bomba e eu tiver kick, ela ganha velocidade
				end
				
				if col.type == "slide" then--and dy ~= 0, e fazer outro pra dx ~= 0
					if dx > 0 then posx = 1 elseif dx < 0 then posx = -1 end
--bug atual: se eu ir pra direita e cima no primeiro Q, eu sumo, pois ele me joga pra cima no Q errado (rever o floor e ceil pra analisar os Qs corretamente)
					if    (col.touch.x % cellsize) == 0
					  and (col.touch.y % cellsize) < 15 --if [...] elseif > 17 [...], para considerar a metade de cima ou de baixo do bloco
					  and (col.touch.y % cellsize) > .1
					  and CheckCollisions(col.item,GetRealPos(actualx, actualy, posx, 0)) == false --checar o da linha da frente pra onde vou entrar
					  --and posx > 0 --aqui eu escolho se quero entrar pra direita ou esquerda, e removo a tremida
					  then
						--[opção 1
						if CheckCollisions(col.item,GetRealPos(actualx, actualy, col.item.x, -1)) == false then --se em cima estiver vazio
							
							if math.floor(col.item.y / 32) > math.floor((col.item.y - col.item.speed*dt) / 32) then--se o Q onde estou for maior do Q da proj y
								actualy = math.floor(col.item.y/32) * 32 --math.floor(col.item.y - col.item.speed*dt)--me coloque de volta no Q de baixo, no limite
								actualx = col.item.x+posx
							else
								actualy = math.floor(col.item.y - col.item.speed*dt)--se o Q onde estou for igual ou menor ao pra onde vou, ando pra cima normal
							end
						end--]]
						
						--[[opção 2
						actualy = math.floor(col.item.y - (col.item.speed/1)*dt)
						if actualy % cellsize > 28 then--or actualy % cellsize < 2 then --essa linha causa a tremida
							actualy = math.ceil(actualy / 32) * 32
							actualx = col.item.x+posx --faz entrar nos vãos, mas X tem que ser um valor inteiro (bug; no vão pra esquerda, teleporto pra direita) --se em frente estiver vazio
						end--]]
					end
				end				
			end
		end
		world:update(player[1], actualx, actualy)
		player[1].x, player[1].y = actualx, actualy
	end
end

function CheckCollisions(player, px, py)
	local items, len = world:queryRect(px*cellsize, py*cellsize,cellsize,cellsize)
		if len > 0 then
			for i=1, len do
				if (items[i].name == "block")
				or (items[i].name == "breakable" and player.passwall == "n")
				or (items[i].name == "bomb" and player.passbomb == "n")
				then
					return true
				end
			end
		end
	return false
end

function GetRealPos(x, y, modx, mody) --pega o quadrado que estou considerando ter mais da metade do personagem
	if not modx then modx = 0 end
	if not mody then mody = 0 end
	if math.floor(x % cellsize) < 16 then x = math.floor(x/cellsize) else x = math.ceil(x/cellsize) end
	if math.floor(y % cellsize) < 16 then y = math.floor(y/cellsize) else y = math.ceil(y/cellsize) end
	return x+modx, y+mody
end

--[[
--and CheckCollisions(col.other,0,posy,"slide",PlayerFilter) == false
function CheckCollisions2(object,movx,movy,col_type,filter)--filter (testar enviar o PlayerFilter de lá)
	--bloco (pois quero ver acima do bloco),
	--movx e movy = 32, -32 (pra saber a direção que estou analisando, se é o bloco de cima, de baixo, da direita, da esquerda)
	--o tipo de colisão que devo retornar se é true ou nao, rodando e comparando com todas as colisões encontradas
	local x, y, cols, cols_len = world:check(object, object.x + movx, object.y + movy, filter)--PlayerFunction
	--local items, len = world:queryRect(l,t,w,h, filter)
	print("check col x: "..math.floor((object.x + movx)/32))
	print("check col y: "..math.floor((object.y + movy)/32))
	if cols_len > 0 then
		for i=1, cols_len do
			local col = cols[i]
			if col.type == col_type then return true end
		end
	end
	local items, len = world:queryRect(object.x+movx, object.y+movy,cellsize,cellsize)
	
	if len > 0 then for i=1, len do if items[i].name == "block" then return true end end end
	
	return false
end
]]