﻿explosion_lifetime = 0.35
Quad = love.graphics.newQuad

explosion = {}
explosion.width = cellsize
explosion.height = cellsize
explosion.particle = love.graphics.newParticleSystem(love.graphics.newImage("/images/burst_0.png"), 999)
explosion.particle:setParticleLifetime(explosion_lifetime)
explosion.particle:setLinearAcceleration(0,0,0,0)
explosion.particle:setQuads(
			Quad(0*cellsize,0,cellsize,cellsize,224,32),
			Quad(1*cellsize,0,cellsize,cellsize,224,32),
			Quad(2*cellsize,0,cellsize,cellsize,224,32),
			Quad(3*cellsize,0,cellsize,cellsize,224,32),
			Quad(4*cellsize,0,cellsize,cellsize,224,32),
			Quad(5*cellsize,0,cellsize,cellsize,224,32),
			Quad(6*cellsize,0,cellsize,cellsize,224,32)
)

breaked = {}
breaked.width = cellsize
breaked.height = cellsize
breaked.particle = love.graphics.newParticleSystem(love.graphics.newImage("/images/breaked_0.png"), 100)
breaked.particle:setParticleLifetime(explosion_lifetime)
breaked.particle:setLinearAcceleration(0,0,0,0)
breaked.particle:setQuads(
			Quad(0*cellsize,0,cellsize,cellsize,128,32),
			Quad(1*cellsize,0,cellsize,cellsize,128,32),
			Quad(2*cellsize,0,cellsize,cellsize,128,32),
			Quad(3*cellsize,0,cellsize,cellsize,128,32)
)

function CollisionUpdate(dt)
	--player[1].collision =
end

function CreatePlayer(n)
	player[n] = {
	name = "player",
	number = n,
	sprite = love.graphics.newImage("/images/player.png"),--_"..n..".png"),
	x = 32,
	y = 32,
	w = cellsize,
	h = cellsize,
	life = 3,
	score = 0,
	speed = 200, --100 inicial
	bombs = {},
	bomb = {img = love.graphics.newImage("/images/bomb.png"), name = "bomb"},
	n_bomb = 3,
	fire = 3, --2 inicial
	glove = "n",
	shoe = "n",
	rubber = "n",
	passbomb = "n",
	passwall = "n",
	inbomb = {},
	fuse = 1.5,--3 inicial
	}
	
end
