﻿--programar para carregar um mapa do tiled, e preencher apenas com os blocos quebráveis aleatoriamente (ou não)

stage_x = 18--mas possui 22, 2 na direita e esquerda, onde exibe informações dos jogadores
stage_y = 14--mas possui 16, 2 acima onde exibe as informações da partida/fase/jogo
stages = {}

stage = {img_block = love.graphics.newImage("/images/block_1.png"), --mudar as imagens de acordo com a fase
		 img_breakable = love.graphics.newImage("/images/breakable_1.png"),
		 img_ground = love.graphics.newImage("/images/ground_0.png"),
		}

stage.blocks = {}
stage.breakables = {}

function LoadStage()--capturar o ID para mudar das imagens de acordo com a fase
	print("iniciando load do stage")
	local newBlock, newBreakable, items, n_items
	
	for i=1, #stage.breakables do
		if stage.breakables[i] then
			world:remove(stage.breakables[i])
			stage.breakables[i]=nil
		end
	end
	print("tabela breakables zerada")
	
	for i=0,stage_x do
		newBlock = {x=i*cellsize,y=0,w=cellsize,h=cellsize,name="block"}
		table.insert(stage.blocks, newBlock)
		world:add(newBlock,newBlock.x,newBlock.y,cellsize,cellsize)
		newBlock = {x=i*cellsize,y=stage_y*cellsize,w=cellsize,h=cellsize,name="block"}
		table.insert(stage.blocks, newBlock)
		world:add(newBlock,newBlock.x,newBlock.y,cellsize,cellsize)
	end
	for i=1,stage_y-1 do
		newBlock = {x=0,y=i*cellsize,w=cellsize,h=cellsize,name="block"}
		table.insert(stage.blocks, newBlock)
		world:add(newBlock,newBlock.x,newBlock.y,cellsize,cellsize)
		newBlock = {x=stage_x*cellsize,y=i*cellsize,w=cellsize,h=cellsize,name="block"}
		table.insert(stage.blocks, newBlock)
		world:add(newBlock,newBlock.x,newBlock.y,cellsize,cellsize)
	end
	print("blocos da borda ok")
	for i = 2, stage_x-2, 2 do
		for j = 2, stage_y-2, 2 do
			newBlock = {x=i*cellsize,y=j*cellsize,w=cellsize,h=cellsize,name="block"}
			table.insert(stage.blocks, newBlock)
			world:add(newBlock,newBlock.x,newBlock.y,cellsize,cellsize)
		end
	end
	print("blocos centrais ok")
	while #stage.breakables < 101 do--math.random(90,100) do
		newBreakable = {x=math.random(1,stage_x-1)*cellsize,y=math.random(1,stage_y-1)*cellsize,name="breakable", id = #stage.breakables + 1}
		items, n_items = world:queryRect(newBreakable.x,newBreakable.y,cellsize,cellsize)
		if n_items == 0
		and not(newBreakable.x <= 2*cellsize and newBreakable.y <= 2*cellsize)
		and not(newBreakable.x <= 2*cellsize and newBreakable.y >= (stage_y-2)*cellsize)
		and not(newBreakable.x >= (stage_x-2)*cellsize and newBreakable.y <= 2*cellsize)
		and not(newBreakable.x >= (stage_x-2)*cellsize and newBreakable.y >= (stage_y-2)*cellsize) then
			stage.breakables[newBreakable.id] = newBreakable
			world:add(newBreakable,newBreakable.x,newBreakable.y,cellsize,cellsize)
			print(#stage.breakables)
		end
		table.remove(newBreakable)
	end
	print("breakables ok, stage carregado")
end